// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.user;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.data.vessel.Vessel;
import java.io.Serializable;
import java.util.Date;

/**
 * @deprecated Use Program2Person instead
 * ATTENTION : NE PLUS UTILISER les portefeuilles dans les nouveaux développements (utiliser à la
 * place les privilèves sur les programmes)
 * Définit la présence de navires sur un portefeuille pour une période début/fin.
 * La période utilisée définit la date des données que peut saisir/modifier/visualiser
 * l'utilisateur, en fonction de ses droits.
 * Exemple :
 * Si un utilisateur a un navire A dans un portefeuille pour la période du 01/01/2002 au 31/12/2002,
 * il peut saisir des données même en 2004, si la date de donnée saisie est pendant l'année 2002.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class VesselManagePeriod
    implements Serializable, Comparable<VesselManagePeriod>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -3872631416617531452L;

    private VesselManagePeriodPK vesselManagePeriodPk;

    /**
     * Get the composite primary key identifier class
     * @return vesselManagePeriodPk
     */
    public VesselManagePeriodPK getVesselManagePeriodPk()
    {
        return this.vesselManagePeriodPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param vesselManagePeriodPkIn
     */
    public void setVesselManagePeriodPk(VesselManagePeriodPK vesselManagePeriodPkIn) {
        this.vesselManagePeriodPk = vesselManagePeriodPkIn;
    }

    // Generate 2 attributes
    /**
     * Date début d'appartenance d'un navire à un portefeuille.
     * @return this.startDateTime Date
     */
    public Date getStartDateTime()
    {
        return this.getVesselManagePeriodPk().getStartDateTime();
    }

    /**
     * Date début d'appartenance d'un navire à un portefeuille.
     * @param startDateTimeIn Date
     */
    public void setStartDateTime(Date startDateTimeIn)
    {
        this.getVesselManagePeriodPk().setStartDateTime(startDateTimeIn);
    }

    private Date endDateTime;

    /**
     * Date fin d'appartenance d'un navire à un portefeuille.
     * @return this.endDateTime Date
     */
    public Date getEndDateTime()
    {
        return this.endDateTime;
    }

    /**
     * Date fin d'appartenance d'un navire à un portefeuille.
     * @param endDateTimeIn Date
     */
    public void setEndDateTime(Date endDateTimeIn)
    {
        this.endDateTime = endDateTimeIn;
    }

    // Generate 2 associations
    private Vessel vessel;

    /**
     * Navire. Peut etre un navire de peche professionnel ou non, un navire océanographique, etc.
     * @return this.vessel Vessel
     */
    public Vessel getVessel()
    {
        return this.vessel;
    }

    /**
     * Navire. Peut etre un navire de peche professionnel ou non, un navire océanographique, etc.
     * @param vesselIn Vessel
     */
    public void setVessel(Vessel vesselIn)
    {
        this.vessel = vesselIn;
    }

    private ManagedData managedData;

    /**
     * @deprecated Use Program2Person instead
     * ATTENTION : NE PLUS UTILISER les portefeuilles dans les nouveaux développements (utiliser à
     * la place
     * les privilèves sur les programmes)
     * Portefeuille de navires.
     * Il peut s'agir d'un portefeuille de différent type (enquete d'activité, marées observées en
     * mer,
     * campagne en mer, etc.)
     * Gestion des droits :
     * - Un portefeuille est géré par un seul utilisateur, qui à les droits de lecture/écriture.
     * - Un portefeuille peut etre supervisé par une tierce personne, qui aura également les droits
     * de
     * lecture/écriture sur les données du portefeuille.
     * - Un portefeuille peut avoir plusieurs utilisateurs avec des droits de consultation
     * uniquement
     * (lecture seule) sur ces données.
     * @return this.managedData ManagedData
     */
    public ManagedData getManagedData()
    {
        return this.managedData;
    }

    /**
     * @deprecated Use Program2Person instead
     * ATTENTION : NE PLUS UTILISER les portefeuilles dans les nouveaux développements (utiliser à
     * la place
     * les privilèves sur les programmes)
     * Portefeuille de navires.
     * Il peut s'agir d'un portefeuille de différent type (enquete d'activité, marées observées en
     * mer,
     * campagne en mer, etc.)
     * Gestion des droits :
     * - Un portefeuille est géré par un seul utilisateur, qui à les droits de lecture/écriture.
     * - Un portefeuille peut etre supervisé par une tierce personne, qui aura également les droits
     * de
     * lecture/écriture sur les données du portefeuille.
     * - Un portefeuille peut avoir plusieurs utilisateurs avec des droits de consultation
     * uniquement
     * (lecture seule) sur ces données.
     * @param managedDataIn ManagedData
     */
    public void setManagedData(ManagedData managedDataIn)
    {
        this.managedData = managedDataIn;
    }

    /**
     * Returns <code>true</code> if the argument is an VesselManagePeriod instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof VesselManagePeriod))
        {
            return false;
        }
        final VesselManagePeriod that = (VesselManagePeriod)object;
        if (this.vesselManagePeriodPk == null || that.vesselManagePeriodPk == null || !this.vesselManagePeriodPk.equals(that.vesselManagePeriodPk))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.vesselManagePeriodPk == null ? 0 : this.vesselManagePeriodPk.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link VesselManagePeriod}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link VesselManagePeriod}.
         * @return new VesselManagePeriodImpl()
         */
        public static VesselManagePeriod newInstance()
        {
            return new VesselManagePeriodImpl();
        }

        /**
         * Constructs a new instance of {@link VesselManagePeriod}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param vessel Vessel
         * @param managedData ManagedData
         * @return newInstance
         */
        public static VesselManagePeriod newInstance(Vessel vessel, ManagedData managedData)
        {
            final VesselManagePeriod entity = new VesselManagePeriodImpl();
            entity.setVessel(vessel);
            entity.setManagedData(managedData);
            return entity;
        }

        /**
         * Constructs a new instance of {@link VesselManagePeriod}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param endDateTime Date
         * @param vessel Vessel
         * @param managedData ManagedData
         * @return newInstance VesselManagePeriod
         */
        public static VesselManagePeriod newInstance(Date endDateTime, Vessel vessel, ManagedData managedData)
        {
            final VesselManagePeriod entity = new VesselManagePeriodImpl();
            entity.setEndDateTime(endDateTime);
            entity.setVessel(vessel);
            entity.setManagedData(managedData);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(VesselManagePeriod o)
    {
        int cmp = 0;
        if (this.getVesselManagePeriodPk() != null)
        {
            cmp = this.getVesselManagePeriodPk().compareTo(o.getVesselManagePeriodPk());
        }
        else
        {
            if (this.getEndDateTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndDateTime().compareTo(o.getEndDateTime()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// VesselManagePeriod.java merge-point
}