// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.link;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.referential.LinkedItemType;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Rapprochement d'une entité d'un type donné à une autre, qui peut etre ou
 * non du meme type.
 * </p>
 * <p>
 * </p>
 * <p>
 * Cette classe permet de gérer des objets ayant un identifiant numérique (<i>objectId</i>)
 * ou un code alphanumérique (<i>objectCode - exemple : Vessel</i>).
 * L'utilisiation du code ou de l'identifiant est exclusive.
 * </p>
 * <p>
 * </p>
 * <p>
 * Un rapprochement peut avoir une période de validité (Optionnel).
 * </p>
 * <p>
 * </p>
 * <p>
 * Exemple d'utilisation : A partir des données VMS, on récupère des
 * informations de navire (Pavillon, nom, dates, etc.) stockées sous la
 * forme d'un navire (Vessel + VesselRegistrationPeriod, etc); après
 * chargement des données VMS, un outil de rapprochement permet de
 * retrouver (ou pas) le navire du fichier flotte national correspondant.
 * La correspondance trouvée est stockée dans <i>LinkedItem</i>.
 * A l'exportation des données VMS depuis Adagio, cela permet de restituer
 * les informations sur le navire telle que présentes dans le flux VMS
 * d'origine.
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class LinkedItem
    implements Serializable, Comparable<LinkedItem>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 5105299700970929294L;

    // Generate 9 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Integer fromObjectId;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Identifiant interne d'une des deux entit&#233;s rapproch&#233;es.
     * </p>
     * <p>
     * Le type d'entit&#233; doit correspondre &#224; celui d&#233;fini dans
     * <i>LinkedItemType.fromObjectType</i>.
     * </p>
     * </body>
     * </html>
     * @return this.fromObjectId Integer
     */
    public Integer getFromObjectId()
    {
        return this.fromObjectId;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Identifiant interne d'une des deux entit&#233;s rapproch&#233;es.
     * </p>
     * <p>
     * Le type d'entit&#233; doit correspondre &#224; celui d&#233;fini dans
     * <i>LinkedItemType.fromObjectType</i>.
     * </p>
     * </body>
     * </html>
     * @param fromObjectIdIn Integer
     */
    public void setFromObjectId(Integer fromObjectIdIn)
    {
        this.fromObjectId = fromObjectIdIn;
    }

    private String fromObjectCode;

    /**
     * 
     * @return this.fromObjectCode String
     */
    public String getFromObjectCode()
    {
        return this.fromObjectCode;
    }

    /**
     * 
     * @param fromObjectCodeIn String
     */
    public void setFromObjectCode(String fromObjectCodeIn)
    {
        this.fromObjectCode = fromObjectCodeIn;
    }

    private Integer toObjectId;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Identifiant interne d'une des deux entit&#233;s rapproch&#233;es.
     * </p>
     * <p>
     * Le type d'entit&#233; doit correspondre &#224; celui d&#233;fini dans
     * <i>LinkedItemType.toObjectType</i>.
     * </p>
     * </body>
     * </html>
     * @return this.toObjectId Integer
     */
    public Integer getToObjectId()
    {
        return this.toObjectId;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Identifiant interne d'une des deux entit&#233;s rapproch&#233;es.
     * </p>
     * <p>
     * Le type d'entit&#233; doit correspondre &#224; celui d&#233;fini dans
     * <i>LinkedItemType.toObjectType</i>.
     * </p>
     * </body>
     * </html>
     * @param toObjectIdIn Integer
     */
    public void setToObjectId(Integer toObjectIdIn)
    {
        this.toObjectId = toObjectIdIn;
    }

    private String toObjectCode;

    /**
     * 
     * @return this.toObjectCode String
     */
    public String getToObjectCode()
    {
        return this.toObjectCode;
    }

    /**
     * 
     * @param toObjectCodeIn String
     */
    public void setToObjectCode(String toObjectCodeIn)
    {
        this.toObjectCode = toObjectCodeIn;
    }

    private Date startDate;

    /**
     * Date de début de validité du rapprochement (optionnel).
     * @return this.startDate Date
     */
    public Date getStartDate()
    {
        return this.startDate;
    }

    /**
     * Date de début de validité du rapprochement (optionnel).
     * @param startDateIn Date
     */
    public void setStartDate(Date startDateIn)
    {
        this.startDate = startDateIn;
    }

    private Date endDate;

    /**
     * Date de fin de validité du rapprochement (optionnel).
     * Doit être vide, si startDate est vide.
     * @return this.endDate Date
     */
    public Date getEndDate()
    {
        return this.endDate;
    }

    /**
     * Date de fin de validité du rapprochement (optionnel).
     * Doit être vide, si startDate est vide.
     * @param endDateIn Date
     */
    public void setEndDate(Date endDateIn)
    {
        this.endDate = endDateIn;
    }

    private Timestamp updateDate;

    /**
     * Date de dernière modification (Mise à jour automatiquement par le système).
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * Date de dernière modification (Mise à jour automatiquement par le système).
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 2 associations
    private QualityFlag qualityFlag;

    /**
     * Indice qualité d'une donnée.
     * Actuellement, les indices qualités identifiés sont :
     * 0 - Non qualifiée,
     * 1 - Bonne,
     * 2 - Hors statistiques,
     * 3 - Douteuse,
     * 4 - Fausse,
     * 5 - Corrigée,
     * 8 - Incomplète,
     * 9 - Absente.
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Indice qualité d'une donnée.
     * Actuellement, les indices qualités identifiés sont :
     * 0 - Non qualifiée,
     * 1 - Bonne,
     * 2 - Hors statistiques,
     * 3 - Douteuse,
     * 4 - Fausse,
     * 5 - Corrigée,
     * 8 - Incomplète,
     * 9 - Absente.
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    private LinkedItemType linkedItemType;

    /**
     * Type de rapprochement effectué.
     * Le type de rapprochement défini les types d'entités mis en jeux dans le rapprochement.
     * @return this.linkedItemType LinkedItemType
     */
    public LinkedItemType getLinkedItemType()
    {
        return this.linkedItemType;
    }

    /**
     * Type de rapprochement effectué.
     * Le type de rapprochement défini les types d'entités mis en jeux dans le rapprochement.
     * @param linkedItemTypeIn LinkedItemType
     */
    public void setLinkedItemType(LinkedItemType linkedItemTypeIn)
    {
        this.linkedItemType = linkedItemTypeIn;
    }

    /**
     * Returns <code>true</code> if the argument is an LinkedItem instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof LinkedItem))
        {
            return false;
        }
        final LinkedItem that = (LinkedItem)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link LinkedItem}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link LinkedItem}.
         * @return new LinkedItemImpl()
         */
        public static LinkedItem newInstance()
        {
            return new LinkedItemImpl();
        }

        /**
         * Constructs a new instance of {@link LinkedItem}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param qualityFlag QualityFlag
         * @param linkedItemType LinkedItemType
         * @return newInstance
         */
        public static LinkedItem newInstance(QualityFlag qualityFlag, LinkedItemType linkedItemType)
        {
            final LinkedItem entity = new LinkedItemImpl();
            entity.setQualityFlag(qualityFlag);
            entity.setLinkedItemType(linkedItemType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link LinkedItem}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param fromObjectId Integer
         * @param fromObjectCode String
         * @param toObjectId Integer
         * @param toObjectCode String
         * @param startDate Date
         * @param endDate Date
         * @param updateDate Timestamp
         * @param remoteId Integer
         * @param qualityFlag QualityFlag
         * @param linkedItemType LinkedItemType
         * @return newInstance LinkedItem
         */
        public static LinkedItem newInstance(Integer fromObjectId, String fromObjectCode, Integer toObjectId, String toObjectCode, Date startDate, Date endDate, Timestamp updateDate, Integer remoteId, QualityFlag qualityFlag, LinkedItemType linkedItemType)
        {
            final LinkedItem entity = new LinkedItemImpl();
            entity.setFromObjectId(fromObjectId);
            entity.setFromObjectCode(fromObjectCode);
            entity.setToObjectId(toObjectId);
            entity.setToObjectCode(toObjectCode);
            entity.setStartDate(startDate);
            entity.setEndDate(endDate);
            entity.setUpdateDate(updateDate);
            entity.setRemoteId(remoteId);
            entity.setQualityFlag(qualityFlag);
            entity.setLinkedItemType(linkedItemType);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(LinkedItem o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getFromObjectId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFromObjectId().compareTo(o.getFromObjectId()));
            }
            if (this.getFromObjectCode() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFromObjectCode().compareTo(o.getFromObjectCode()));
            }
            if (this.getToObjectId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getToObjectId().compareTo(o.getToObjectId()));
            }
            if (this.getToObjectCode() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getToObjectCode().compareTo(o.getToObjectCode()));
            }
            if (this.getStartDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStartDate().compareTo(o.getStartDate()));
            }
            if (this.getEndDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndDate().compareTo(o.getEndDate()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// LinkedItem.java merge-point
}