// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.measure;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.referential.AnalysisInstrument;
import fr.ifremer.adagio.core.dao.referential.NumericalPrecision;
import fr.ifremer.adagio.core.dao.referential.PrecisionType;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel;
import fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import java.io.Serializable;
import java.util.Date;

/**
 * Résultat de mesure générique, servant de base à tous les résultats de mesure liés à un PSFM.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Measurement
    implements Serializable, Comparable<Measurement>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 3525709055852911378L;

    // Generate 10 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Float numericalValue;

    /**
     * <html>
     * <head>
     * <title>V    </title>
     * </head>
     * <body>
     * valeur num&#233;rique de la mesure.<br>Elle est n&#233;cessairement exprim&#233;e
     * dans l'unit&#233; associ&#233; au PSFM de la mesure.
     * <br>
     * Renseign&#233; uniquement pour un PSFM num&#233;rique
     * (PMFM.parameter.isQualitative=false)
     * </body>
     * </html>
     * @return this.numericalValue Float
     */
    public Float getNumericalValue()
    {
        return this.numericalValue;
    }

    /**
     * <html>
     * <head>
     * <title>V    </title>
     * </head>
     * <body>
     * valeur num&#233;rique de la mesure.<br>Elle est n&#233;cessairement exprim&#233;e
     * dans l'unit&#233; associ&#233; au PSFM de la mesure.
     * <br>
     * Renseign&#233; uniquement pour un PSFM num&#233;rique
     * (PMFM.parameter.isQualitative=false)
     * </body>
     * </html>
     * @param numericalValueIn Float
     */
    public void setNumericalValue(Float numericalValueIn)
    {
        this.numericalValue = numericalValueIn;
    }

    private String alphanumericalValue;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Valeur alphanum&#233;rique de la mesure.
     * <br>    </p>
     * <p>
     * <br>
     * <u>Attention :</u> <b>Utilisation &#224; &#233;viter</b>. A utiliser
     * uniquement dans des cas ou les valeurs qualitatives ne peuvent pas
     * convenir (format non fixe, etc.).
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemples :<br>* Num&#233;ros de contrat (Ventre ERS)<br>* Type de
     * dimension d'engin (logbook - flux SACAPT) &quot;2X60&quot;, &quot;2x6 dragues 75&quot;,
     * &quot;13.9x2&quot;, &quot;2x7m&#178;&quot;, &quot;2x17.50&quot;, &quot;2m x 2&quot;, etc
     * </p>
     * </body>
     * </html>
     * @return this.alphanumericalValue String
     */
    public String getAlphanumericalValue()
    {
        return this.alphanumericalValue;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Valeur alphanum&#233;rique de la mesure.
     * <br>    </p>
     * <p>
     * <br>
     * <u>Attention :</u> <b>Utilisation &#224; &#233;viter</b>. A utiliser
     * uniquement dans des cas ou les valeurs qualitatives ne peuvent pas
     * convenir (format non fixe, etc.).
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemples :<br>* Num&#233;ros de contrat (Ventre ERS)<br>* Type de
     * dimension d'engin (logbook - flux SACAPT) &quot;2X60&quot;, &quot;2x6 dragues 75&quot;,
     * &quot;13.9x2&quot;, &quot;2x7m&#178;&quot;, &quot;2x17.50&quot;, &quot;2m x 2&quot;, etc
     * </p>
     * </body>
     * </html>
     * @param alphanumericalValueIn String
     */
    public void setAlphanumericalValue(String alphanumericalValueIn)
    {
        this.alphanumericalValue = alphanumericalValueIn;
    }

    private Integer digitCount;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Nombre de digits saisis dans la valeur num&#233;rique de la mesure.
     * </p>
     * <p>
     * </p>
     * <p>
     * Cela permet de stocker &quot;10.00&quot; (numericalvalue=10 et digitCount=2) et de
     * pouvoir restituer la valeur sous la meme forme.
     * </p>
     * </body>
     * </html>
     * @return this.digitCount Integer
     */
    public Integer getDigitCount()
    {
        return this.digitCount;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Nombre de digits saisis dans la valeur num&#233;rique de la mesure.
     * </p>
     * <p>
     * </p>
     * <p>
     * Cela permet de stocker &quot;10.00&quot; (numericalvalue=10 et digitCount=2) et de
     * pouvoir restituer la valeur sous la meme forme.
     * </p>
     * </body>
     * </html>
     * @param digitCountIn Integer
     */
    public void setDigitCount(Integer digitCountIn)
    {
        this.digitCount = digitCountIn;
    }

    private Float precisionValue;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Pr&#233;cision de la mesure. Par exemple : precisioNValue=0.5 pour indiquer
     * une pr&#233;cision &#224; + ou - &quot;0.5&quot;.
     * <br>    </p>
     * <p>
     * </p>
     * <p>
     * Valeur exprim&#233;e soit dans l'unite de la mesure (ex : &quot;mm&quot;), soit en
     * poucentage de la mesure (suivant la valeur de <i>PrecisionType</i>).
     * </p>
     * </body>
     * </html>
     * @return this.precisionValue Float
     */
    public Float getPrecisionValue()
    {
        return this.precisionValue;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Pr&#233;cision de la mesure. Par exemple : precisioNValue=0.5 pour indiquer
     * une pr&#233;cision &#224; + ou - &quot;0.5&quot;.
     * <br>    </p>
     * <p>
     * </p>
     * <p>
     * Valeur exprim&#233;e soit dans l'unite de la mesure (ex : &quot;mm&quot;), soit en
     * poucentage de la mesure (suivant la valeur de <i>PrecisionType</i>).
     * </p>
     * </body>
     * </html>
     * @param precisionValueIn Float
     */
    public void setPrecisionValue(Float precisionValueIn)
    {
        this.precisionValue = precisionValueIn;
    }

    private Date controlDate;

    /**
     * Date du controle de la donnée.
     * Le controle est la première phase de validation de la donnée.
     * Exemple :
     * - Dans Allegro, ce controle est effectué lorsque l'utilisateur a achevé sa saisie et qu'il
     * souhaite "Terminer la saisie", dans le but de transmettre ses données au système centrale.
     * Les controle effectué par Allegro sur le poste client sont des vérifications sur les champs
     * obligatoires, ou encore sur la cohérence des données (cas d'un arbre d'échantillonnage).
     * @return this.controlDate Date
     */
    public Date getControlDate()
    {
        return this.controlDate;
    }

    /**
     * Date du controle de la donnée.
     * Le controle est la première phase de validation de la donnée.
     * Exemple :
     * - Dans Allegro, ce controle est effectué lorsque l'utilisateur a achevé sa saisie et qu'il
     * souhaite "Terminer la saisie", dans le but de transmettre ses données au système centrale.
     * Les controle effectué par Allegro sur le poste client sont des vérifications sur les champs
     * obligatoires, ou encore sur la cohérence des données (cas d'un arbre d'échantillonnage).
     * @param controlDateIn Date
     */
    public void setControlDate(Date controlDateIn)
    {
        this.controlDate = controlDateIn;
    }

    private Date validationDate;

    /**
     * Date de validation de la donnée.
     * La validation est typiquement effectué par un thématicien responsable des données. Dans
     * Allegro, il s'agit du superviseur du portefeuille de données qui en est responsable.
     * @return this.validationDate Date
     */
    public Date getValidationDate()
    {
        return this.validationDate;
    }

    /**
     * Date de validation de la donnée.
     * La validation est typiquement effectué par un thématicien responsable des données. Dans
     * Allegro, il s'agit du superviseur du portefeuille de données qui en est responsable.
     * @param validationDateIn Date
     */
    public void setValidationDate(Date validationDateIn)
    {
        this.validationDate = validationDateIn;
    }

    private Date qualificationDate;

    /**
     * Date de qualification de la donnée.
     * L'étape de qualification est liée à l'affectation d'un flag qualité (bon, mauvais, etc.) sur
     * la donnée.
     * - la qualification n'est pas encore gérée dans Allegro, dans le sens ou il n'existe pass
     * encore d'interface pour affecter le flag qualité. Par défaut, le niveau de qualité est donc à
     * "non qualifiée"
     * @return this.qualificationDate Date
     */
    public Date getQualificationDate()
    {
        return this.qualificationDate;
    }

    /**
     * Date de qualification de la donnée.
     * L'étape de qualification est liée à l'affectation d'un flag qualité (bon, mauvais, etc.) sur
     * la donnée.
     * - la qualification n'est pas encore gérée dans Allegro, dans le sens ou il n'existe pass
     * encore d'interface pour affecter le flag qualité. Par défaut, le niveau de qualité est donc à
     * "non qualifiée"
     * @param qualificationDateIn Date
     */
    public void setQualificationDate(Date qualificationDateIn)
    {
        this.qualificationDate = qualificationDateIn;
    }

    private String qualificationComments;

    /**
     * 
     * @return this.qualificationComments String
     */
    public String getQualificationComments()
    {
        return this.qualificationComments;
    }

    /**
     * 
     * @param qualificationCommentsIn String
     */
    public void setQualificationComments(String qualificationCommentsIn)
    {
        this.qualificationComments = qualificationCommentsIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 8 associations
    private AggregationLevel aggregationLevel;

    /**
     * Niveau (ou période) d'agrégation de la donnée.
     * Par exemple :
     * - aucune (pas d'agrégation)
     * - jour,
     * - mois,
     * - année
     * - marée
     * - opération
     * - zone de peche (cas des séquences de peche ?)
     * Utiliser une période d'agrégation permet de définir des valeurs moyennes sur une période
     * d'agrégation (par exemple : le mois) indépendamment de la période concernée (par exemple :
     * une
     * année).
     * Exemple :
     * - moyenne mensuelle sur l'année, du nombre d'engin levé par jour :
     * - paramètre : nombre d'engin levé
     * - niveau d'agrégation du PSFM : jour
     * - période concerné : 01/01/XX au 31/12/XX : définie au niveau de l'entité à laquelle est
     * rattachée
     * la mesure (exemple : la marée, l'opération, les caractéristiques d'utilisation, etc.).
     * - période d'agrégation sur la mesure (xxxMeasurement) : mois
     * @return this.aggregationLevel AggregationLevel
     */
    public AggregationLevel getAggregationLevel()
    {
        return this.aggregationLevel;
    }

    /**
     * Niveau (ou période) d'agrégation de la donnée.
     * Par exemple :
     * - aucune (pas d'agrégation)
     * - jour,
     * - mois,
     * - année
     * - marée
     * - opération
     * - zone de peche (cas des séquences de peche ?)
     * Utiliser une période d'agrégation permet de définir des valeurs moyennes sur une période
     * d'agrégation (par exemple : le mois) indépendamment de la période concernée (par exemple :
     * une
     * année).
     * Exemple :
     * - moyenne mensuelle sur l'année, du nombre d'engin levé par jour :
     * - paramètre : nombre d'engin levé
     * - niveau d'agrégation du PSFM : jour
     * - période concerné : 01/01/XX au 31/12/XX : définie au niveau de l'entité à laquelle est
     * rattachée
     * la mesure (exemple : la marée, l'opération, les caractéristiques d'utilisation, etc.).
     * - période d'agrégation sur la mesure (xxxMeasurement) : mois
     * @param aggregationLevelIn AggregationLevel
     */
    public void setAggregationLevel(AggregationLevel aggregationLevelIn)
    {
        this.aggregationLevel = aggregationLevelIn;
    }

    private QualityFlag qualityFlag;

    /**
     * Niveau de qualité de la donnée.
     * "Non qualifiée" par défaut
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Niveau de qualité de la donnée.
     * "Non qualifiée" par défaut
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    private PrecisionType precisionType;

    /**
     * Type d'incertitude, par exemple intervalle de confiance ou % d'incertitude
     * @return this.precisionType PrecisionType
     */
    public PrecisionType getPrecisionType()
    {
        return this.precisionType;
    }

    /**
     * Type d'incertitude, par exemple intervalle de confiance ou % d'incertitude
     * @param precisionTypeIn PrecisionType
     */
    public void setPrecisionType(PrecisionType precisionTypeIn)
    {
        this.precisionType = precisionTypeIn;
    }

    private AnalysisInstrument analysisInstrument;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Instrument de mesure utilis&#233; pour effectuer la mesure.
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple : un Ichtyom&#232;tre, un pied &#224; coulisse, etc.
     * </p>
     * </body>
     * </html>
     * @return this.analysisInstrument AnalysisInstrument
     */
    public AnalysisInstrument getAnalysisInstrument()
    {
        return this.analysisInstrument;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Instrument de mesure utilis&#233; pour effectuer la mesure.
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple : un Ichtyom&#232;tre, un pied &#224; coulisse, etc.
     * </p>
     * </body>
     * </html>
     * @param analysisInstrumentIn AnalysisInstrument
     */
    public void setAnalysisInstrument(AnalysisInstrument analysisInstrumentIn)
    {
        this.analysisInstrument = analysisInstrumentIn;
    }

    private NumericalPrecision numericalPrecision;

    /**
     * Précision de la mesure par rapport au seuil de détection de l'instrument d'analyse. Se
     * trouve-t-on
     * au dessus ou en dessous du seuil de détection ?
     * Utilisée principalement lors de l'utilisation d'instrument de mesure.
     * La liste sera la suivante :
     * - supérieure valeur maximale pouvant être détectée
     * - inférieure à la valeur minimale pouvant être détectée
     * @return this.numericalPrecision NumericalPrecision
     */
    public NumericalPrecision getNumericalPrecision()
    {
        return this.numericalPrecision;
    }

    /**
     * Précision de la mesure par rapport au seuil de détection de l'instrument d'analyse. Se
     * trouve-t-on
     * au dessus ou en dessous du seuil de détection ?
     * Utilisée principalement lors de l'utilisation d'instrument de mesure.
     * La liste sera la suivante :
     * - supérieure valeur maximale pouvant être détectée
     * - inférieure à la valeur minimale pouvant être détectée
     * @param numericalPrecisionIn NumericalPrecision
     */
    public void setNumericalPrecision(NumericalPrecision numericalPrecisionIn)
    {
        this.numericalPrecision = numericalPrecisionIn;
    }

    private Department department;

    /**
     * Service effectuant l'analyse/la mesure.
     * Par défaut, le service de l'observateur est utilisé.
     * @return this.department Department
     */
    public Department getDepartment()
    {
        return this.department;
    }

    /**
     * Service effectuant l'analyse/la mesure.
     * Par défaut, le service de l'observateur est utilisé.
     * @param departmentIn Department
     */
    public void setDepartment(Department departmentIn)
    {
        this.department = departmentIn;
    }

    private Pmfm pmfm;

    /**
     * Il s'agit du contexte de réalisation de la mesure (PSFM).
     * @return this.pmfm Pmfm
     */
    public Pmfm getPmfm()
    {
        return this.pmfm;
    }

    /**
     * Il s'agit du contexte de réalisation de la mesure (PSFM).
     * @param pmfmIn Pmfm
     */
    public void setPmfm(Pmfm pmfmIn)
    {
        this.pmfm = pmfmIn;
    }

    private QualitativeValue qualitativeValue;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * Valeur qualitative choisie.
     * <br>Renseign&#233; uniquement pour un PSFM qualtitatif
     * (PMFM.parameter.isQualitative=true)
     * </body>
     * </html>
     * @return this.qualitativeValue QualitativeValue
     */
    public QualitativeValue getQualitativeValue()
    {
        return this.qualitativeValue;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * Valeur qualitative choisie.
     * <br>Renseign&#233; uniquement pour un PSFM qualtitatif
     * (PMFM.parameter.isQualitative=true)
     * </body>
     * </html>
     * @param qualitativeValueIn QualitativeValue
     */
    public void setQualitativeValue(QualitativeValue qualitativeValueIn)
    {
        this.qualitativeValue = qualitativeValueIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Measurement instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Measurement))
        {
            return false;
        }
        final Measurement that = (Measurement)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Measurement o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getNumericalValue() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getNumericalValue().compareTo(o.getNumericalValue()));
            }
            if (this.getAlphanumericalValue() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getAlphanumericalValue().compareTo(o.getAlphanumericalValue()));
            }
            if (this.getDigitCount() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDigitCount().compareTo(o.getDigitCount()));
            }
            if (this.getPrecisionValue() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPrecisionValue().compareTo(o.getPrecisionValue()));
            }
            if (this.getControlDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getControlDate().compareTo(o.getControlDate()));
            }
            if (this.getValidationDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getValidationDate().compareTo(o.getValidationDate()));
            }
            if (this.getQualificationDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getQualificationDate().compareTo(o.getQualificationDate()));
            }
            if (this.getQualificationComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getQualificationComments().compareTo(o.getQualificationComments()));
            }
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Measurement.java merge-point
}