// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.data.history.ProcessingHistory;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * Etat d'un traitement.
 * </p>
 * <p>
 * </p>
 * <p>
 * Par exemple :<br>- succ&#232;s<br>- &#233;chec<br>- etc.
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class ProcessingStatus
    implements Serializable, Comparable<ProcessingStatus>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1760311780122299188L;

    // Generate 3 attributes
    private String code;

    /**
     * Code de l'état d'un traitement.
     * Gébnéralement, parmi : SUCCESS, ERROR, WARNING, etc.
     * @return this.code String
     */
    public String getCode()
    {
        return this.code;
    }

    /**
     * Code de l'état d'un traitement.
     * Gébnéralement, parmi : SUCCESS, ERROR, WARNING, etc.
     * @param codeIn String
     */
    public void setCode(String codeIn)
    {
        this.code = codeIn;
    }

    private String name;

    /**
     * Libellé de l'état d'execution d'un traitement
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * Libellé de l'état d'execution d'un traitement
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 2 associations
    private Status status;

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<ProcessingHistory> processingHistories = new HashSet<ProcessingHistory>();

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Historique des traitements, qu’il s’agisse de flux (comme historiquement
     * la table HIS_FLUX) ou non (traitement d’agrégation, CQ auto, etc.).
     * </p>
     * <p>
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * Permet donc de conserver l'historique des traitements qui se sont
     * exécutés sur le système, notamment ceux qui ont impactés la base de
     * données brutes (Adagio).
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * L’exécution des traitements en erreur peuvent également être tracée.
     * </p>
     * </body>
     * </html>
     * @return this.processingHistories Collection<ProcessingHistory>
     */
    public Collection<ProcessingHistory> getProcessingHistories()
    {
        return this.processingHistories;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Historique des traitements, qu’il s’agisse de flux (comme historiquement
     * la table HIS_FLUX) ou non (traitement d’agrégation, CQ auto, etc.).
     * </p>
     * <p>
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * Permet donc de conserver l'historique des traitements qui se sont
     * exécutés sur le système, notamment ceux qui ont impactés la base de
     * données brutes (Adagio).
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * L’exécution des traitements en erreur peuvent également être tracée.
     * </p>
     * </body>
     * </html>
     * @param processingHistoriesIn Collection<ProcessingHistory>
     */
    public void setProcessingHistories(Collection<ProcessingHistory> processingHistoriesIn)
    {
        this.processingHistories = processingHistoriesIn;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Historique des traitements, qu’il s’agisse de flux (comme historiquement
     * la table HIS_FLUX) ou non (traitement d’agrégation, CQ auto, etc.).
     * </p>
     * <p>
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * Permet donc de conserver l'historique des traitements qui se sont
     * exécutés sur le système, notamment ceux qui ont impactés la base de
     * données brutes (Adagio).
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * L’exécution des traitements en erreur peuvent également être tracée.
     * </p>
     * </body>
     * </html>
     * @param elementToAdd ProcessingHistory
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addProcessingHistories(ProcessingHistory elementToAdd)
    {
        return this.processingHistories.add(elementToAdd);
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Historique des traitements, qu’il s’agisse de flux (comme historiquement
     * la table HIS_FLUX) ou non (traitement d’agrégation, CQ auto, etc.).
     * </p>
     * <p>
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * Permet donc de conserver l'historique des traitements qui se sont
     * exécutés sur le système, notamment ceux qui ont impactés la base de
     * données brutes (Adagio).
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * </p>
     * <p style="font-family:Times New
     * Roman,serif;margin-bottom:.0001pt;margin-left:0cm;margin-top:0cm;font-size:12.0pt;">
     * L’exécution des traitements en erreur peuvent également être tracée.
     * </p>
     * </body>
     * </html>
     * @param elementToRemove ProcessingHistory
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeProcessingHistories(ProcessingHistory elementToRemove)
    {
        return this.processingHistories.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an ProcessingStatus instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof ProcessingStatus))
        {
            return false;
        }
        final ProcessingStatus that = (ProcessingStatus)object;
        if (this.code == null || that.getCode() == null || !this.code.equals(that.getCode()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.code == null ? 0 : this.code.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link ProcessingStatus}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link ProcessingStatus}.
         * @return new ProcessingStatusImpl()
         */
        public static ProcessingStatus newInstance()
        {
            return new ProcessingStatusImpl();
        }

        /**
         * Constructs a new instance of {@link ProcessingStatus}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param name String
         * @param status Status
         * @return newInstance
         */
        public static ProcessingStatus newInstance(String name, Status status)
        {
            final ProcessingStatus entity = new ProcessingStatusImpl();
            entity.setName(name);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link ProcessingStatus}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param name String
         * @param updateDate Timestamp
         * @param status Status
         * @param processingHistories Collection<ProcessingHistory>
         * @return newInstance ProcessingStatus
         */
        public static ProcessingStatus newInstance(String name, Timestamp updateDate, Status status, Collection<ProcessingHistory> processingHistories)
        {
            final ProcessingStatus entity = new ProcessingStatusImpl();
            entity.setName(name);
            entity.setUpdateDate(updateDate);
            entity.setStatus(status);
            entity.setProcessingHistories(processingHistories);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(ProcessingStatus o)
    {
        int cmp = 0;
        if (this.getCode() != null)
        {
            cmp = this.getCode().compareTo(o.getCode());
        }
        else
        {
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// ProcessingStatus.java merge-point
}