// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.gear;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.Status;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * D&#233;fini un engin, non pas engin physique, mais au sens &quot;classe d'engin&quot;.
 * </p>
 * <p>
 * Il est possible de d&#233;finir un arboresence d'engin, au sein d'une meme
 * classification, via les liens d'engin parents/enfants.
 * </p>
 * <p>
 * <br>
 * </p>
 * <p>
 * Exemple, pour la classification 'Engin EU corpus' :
 * </p>
 * <p>
 * * 'corpus effort de p&#234;che'<br>- PAL Palangre de surface (Longliner)<br>
 * </p>
 * <p>
 * - EP1 Engins petits p&#233;lagiques - corpus r&#233;glementaire 685/95
 * </p>
 * <p>
 * * corpus 2 (...)<br>- ...
 * </p>
 * <p>
 * <br>
 * </p>
 * <p>
 * Exemple, pour la classification 'FAO/CISTEP' :<br>* 'chaluts' (code
 * '03.0.0')<br>
 * </p>
 * <p>
 * - 'OTB' 'chalut de fond'<br>
 * </p>
 * <p>
 * - chalut p&#233;lagique
 * </p>
 * <p>
 * - ...<br>* 'Filets'
 * </p>
 * </body>
 * </html>
 * @see Gear
 */
public interface GearDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Gear}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of Gear from the persistent store.
     * @param id
     * @return Gear
     */
    public Gear get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of Gear from the persistent store.
     * @param id
     * @return Gear
     */
    public Gear load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link Gear}.
     *
     * @return the loaded entities.
     */
    public Collection<Gear> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Gear and adds it to the persistent store.
     * @param gear
     * @return Gear
     */
    public Gear create(Gear gear);

    /**
     * <p>
     * Does the same thing as {@link #create(Gear)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param gear
     * @return Object
     */
    public Object create(int transform, Gear gear);

    /**
     * Creates a new instance of Gear and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Gear
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Gear> create(Collection<Gear> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Gear)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Gear> entities);

    /**
     * <p>
     * Creates a new <code>Gear</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param label Mnémonique (ou code) de l'engin. Le mnémonique doit être unique pour une meme classification
d'engin.
Par exemple : - Pour la classification FAO/CSITEP : label='OTB'
     * @param name Libellé de l'engin.
il s'agit du libellé "officiel" de la classification.
note : ce libellé peut etre régionalisé via "GearLocation".
     * @param description 
     * @param updateDate 
     * @return Gear
     */
    public Gear create(
        String label,
        String name,
        String description,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param label Mnémonique (ou code) de l'engin. Le mnémonique doit être unique pour une meme classification
d'engin.
Par exemple : - Pour la classification FAO/CSITEP : label='OTB'
     * @param name Libellé de l'engin.
il s'agit du libellé "officiel" de la classification.
note : ce libellé peut etre régionalisé via "GearLocation".
     * @param description 
     * @param updateDate 
     * @return Gear
     */
    public Object create(
        int transform,
        String label,
        String name,
        String description,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>Gear</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param gearClassification
     * @param label
     * @param name
     * @param status
     * @return Gear
     */
    public Gear create(
        GearClassification gearClassification,
        String label,
        String name,
        Status status);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param gearClassification
     * @param label
     * @param name
     * @param status
     * @return Object
     */
    public Object create(
        int transform,
        GearClassification gearClassification,
        String label,
        String name,
        Status status);

    /**
     * Updates the <code>gear</code> instance in the persistent store.
     * @param gear
     */
    public void update(Gear gear);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Gear> entities);

    /**
     * Removes the instance of Gear from the persistent store.
     * @param gear
     */
    public void remove(Gear gear);

    /**
     * Removes the instance of Gear having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Gear> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Gear> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.referential.gear.GearDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.referential.gear.GearDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Gear entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Gear)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.referential.gear.GearDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Gear)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}