// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.technical.optimization.location;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.io.Serializable;

/**
 * 
 */
// HibernateEntity.vsl annotations merge-point
public abstract class LocationHierarchy
    implements Serializable, Comparable<LocationHierarchy>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -2311095031259661897L;

    private LocationHierarchyPK locationHierarchyPk;

    /**
     * Get the composite primary key identifier class
     * @return locationHierarchyPk
     */
    public LocationHierarchyPK getLocationHierarchyPk()
    {
        return this.locationHierarchyPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param locationHierarchyPkIn
     */
    public void setLocationHierarchyPk(LocationHierarchyPK locationHierarchyPkIn) {
        this.locationHierarchyPk = locationHierarchyPkIn;
    }

    // Generate 2 attributes
    private Float childSurfaceRatio = Float.valueOf("1.0");

    /**
     * Ratio de couverture (en surface) du lieu fils par rapport au lieu père. La valeur doit etre
     * supérieure strictement à 0 et inférieur ou égale à 1.
     * Déduit à partir de la valeur de  LocationAssociation.childSurfaceRatio, selon un algorithme
     * de parcours d'arbre (cf procedure stockée P_FILL_LOCATION_HIERARCHY)
     * @return this.childSurfaceRatio Float
     */
    public Float getChildSurfaceRatio()
    {
        return this.childSurfaceRatio;
    }

    /**
     * Ratio de couverture (en surface) du lieu fils par rapport au lieu père. La valeur doit etre
     * supérieure strictement à 0 et inférieur ou égale à 1.
     * Déduit à partir de la valeur de  LocationAssociation.childSurfaceRatio, selon un algorithme
     * de parcours d'arbre (cf procedure stockée P_FILL_LOCATION_HIERARCHY)
     * @param childSurfaceRatioIn Float
     */
    public void setChildSurfaceRatio(Float childSurfaceRatioIn)
    {
        this.childSurfaceRatio = childSurfaceRatioIn;
    }

    private Boolean isMainAssociation;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Indique si l'association est considérée comme la principale.
     * </p>
     * <p>
     * Dans le cas d'une zone en mer rattachée à plusieurs zones parente, cela
     * permet de de récupérer qu'une seule zone (utiliser notamment pour le&#160;SIG
     * SIH)
     * </p>
     * </body>
     * </html>
     * @return this.isMainAssociation Boolean
     */
    public Boolean isIsMainAssociation()
    {
        return this.isMainAssociation;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Indique si l'association est considérée comme la principale.
     * </p>
     * <p>
     * Dans le cas d'une zone en mer rattachée à plusieurs zones parente, cela
     * permet de de récupérer qu'une seule zone (utiliser notamment pour le&#160;SIG
     * SIH)
     * </p>
     * </body>
     * </html>
     * @param isMainAssociationIn Boolean
     */
    public void setIsMainAssociation(Boolean isMainAssociationIn)
    {
        this.isMainAssociation = isMainAssociationIn;
    }

    // Generate 2 associations
    private Location location;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.location Location
     */
    public Location getLocation()
    {
        return this.location;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param locationIn Location
     */
    public void setLocation(Location locationIn)
    {
        this.location = locationIn;
    }

    private Location parent;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.parent Location
     */
    public Location getParent()
    {
        return this.parent;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param parentIn Location
     */
    public void setParent(Location parentIn)
    {
        this.parent = parentIn;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only take the identifiers of this entity into account when calculating the hash code.
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link LocationHierarchy}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link LocationHierarchy}.
         * @return new LocationHierarchyImpl()
         */
        public static LocationHierarchy newInstance()
        {
            return new LocationHierarchyImpl();
        }


        /**
         * Constructs a new instance of {@link LocationHierarchy}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param childSurfaceRatio Float
         * @param isMainAssociation Boolean
         * @param location Location
         * @param parent Location
         * @return newInstance LocationHierarchy
         */
        public static LocationHierarchy newInstance(Float childSurfaceRatio, Boolean isMainAssociation, Location location, Location parent)
        {
            final LocationHierarchy entity = new LocationHierarchyImpl();
            entity.setChildSurfaceRatio(childSurfaceRatio);
            entity.setIsMainAssociation(isMainAssociation);
            entity.setLocation(location);
            entity.setParent(parent);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(LocationHierarchy o)
    {
        int cmp = 0;
        if (this.getLocationHierarchyPk() != null)
        {
            cmp = this.getLocationHierarchyPk().compareTo(o.getLocationHierarchyPk());
        }
            if (this.getChildSurfaceRatio() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getChildSurfaceRatio().compareTo(o.getChildSurfaceRatio()));
            }
            if (this.isIsMainAssociation() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsMainAssociation().compareTo(o.isIsMainAssociation()));
            }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// LocationHierarchy.java merge-point
}