// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.technical.optimization.taxon;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon;
import fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup;
import java.io.Serializable;
import java.util.Date;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Table technique présentant tous les liens (directs et hérités) entre les
 * groupes de taxons et les références de taxon.
 * </p>
 * <p>
 * </p>
 * <p>
 * Cette table est remplie à partir du contenu de <i>TaxonGroupHistoricalRecord</i>,
 * par un procédure stockée à lancer depuis la base de données Oracle.
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TaxonGroup2TaxonHierarchy
    implements Serializable, Comparable<TaxonGroup2TaxonHierarchy>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1118756134410598453L;

    private TaxonGroup2TaxonHierarchyPK taxonGroup2TaxonHierarchyPk;

    /**
     * Get the composite primary key identifier class
     * @return taxonGroup2TaxonHierarchyPk
     */
    public TaxonGroup2TaxonHierarchyPK getTaxonGroup2TaxonHierarchyPk()
    {
        return this.taxonGroup2TaxonHierarchyPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param taxonGroup2TaxonHierarchyPkIn
     */
    public void setTaxonGroup2TaxonHierarchyPk(TaxonGroup2TaxonHierarchyPK taxonGroup2TaxonHierarchyPkIn) {
        this.taxonGroup2TaxonHierarchyPk = taxonGroup2TaxonHierarchyPkIn;
    }

    // Generate 3 attributes
    /**
     * 
     * @return this.startDate Date
     */
    public Date getStartDate()
    {
        return this.getTaxonGroup2TaxonHierarchyPk().getStartDate();
    }

    /**
     * 
     * @param startDateIn Date
     */
    public void setStartDate(Date startDateIn)
    {
        this.getTaxonGroup2TaxonHierarchyPk().setStartDate(startDateIn);
    }

    private Date endDate;

    /**
     * 
     * @return this.endDate Date
     */
    public Date getEndDate()
    {
        return this.endDate;
    }

    /**
     * 
     * @param endDateIn Date
     */
    public void setEndDate(Date endDateIn)
    {
        this.endDate = endDateIn;
    }

    private Boolean isInherited;

    /**
     * 
     * @return this.isInherited Boolean
     */
    public Boolean isIsInherited()
    {
        return this.isInherited;
    }

    /**
     * 
     * @param isInheritedIn Boolean
     */
    public void setIsInherited(Boolean isInheritedIn)
    {
        this.isInherited = isInheritedIn;
    }

    // Generate 2 associations
    private ReferenceTaxon childReferenceTaxon;

    /**
     * 
     * @return this.childReferenceTaxon ReferenceTaxon
     */
    public ReferenceTaxon getChildReferenceTaxon()
    {
        return this.childReferenceTaxon;
    }

    /**
     * 
     * @param childReferenceTaxonIn ReferenceTaxon
     */
    public void setChildReferenceTaxon(ReferenceTaxon childReferenceTaxonIn)
    {
        this.childReferenceTaxon = childReferenceTaxonIn;
    }

    private TaxonGroup parentTaxonGroup;

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @return this.parentTaxonGroup TaxonGroup
     */
    public TaxonGroup getParentTaxonGroup()
    {
        return this.parentTaxonGroup;
    }

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @param parentTaxonGroupIn TaxonGroup
     */
    public void setParentTaxonGroup(TaxonGroup parentTaxonGroupIn)
    {
        this.parentTaxonGroup = parentTaxonGroupIn;
    }

    /**
     * Returns <code>true</code> if the argument is an TaxonGroup2TaxonHierarchy instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TaxonGroup2TaxonHierarchy))
        {
            return false;
        }
        final TaxonGroup2TaxonHierarchy that = (TaxonGroup2TaxonHierarchy)object;
        if (this.taxonGroup2TaxonHierarchyPk == null || that.taxonGroup2TaxonHierarchyPk == null || !this.taxonGroup2TaxonHierarchyPk.equals(that.taxonGroup2TaxonHierarchyPk))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.taxonGroup2TaxonHierarchyPk == null ? 0 : this.taxonGroup2TaxonHierarchyPk.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link TaxonGroup2TaxonHierarchy}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TaxonGroup2TaxonHierarchy}.
         * @return new TaxonGroup2TaxonHierarchyImpl()
         */
        public static TaxonGroup2TaxonHierarchy newInstance()
        {
            return new TaxonGroup2TaxonHierarchyImpl();
        }

        /**
         * Constructs a new instance of {@link TaxonGroup2TaxonHierarchy}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param isInherited Boolean
         * @param childReferenceTaxon ReferenceTaxon
         * @param parentTaxonGroup TaxonGroup
         * @return newInstance
         */
        public static TaxonGroup2TaxonHierarchy newInstance(Boolean isInherited, ReferenceTaxon childReferenceTaxon, TaxonGroup parentTaxonGroup)
        {
            final TaxonGroup2TaxonHierarchy entity = new TaxonGroup2TaxonHierarchyImpl();
            entity.setIsInherited(isInherited);
            entity.setChildReferenceTaxon(childReferenceTaxon);
            entity.setParentTaxonGroup(parentTaxonGroup);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TaxonGroup2TaxonHierarchy}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param endDate Date
         * @param isInherited Boolean
         * @param childReferenceTaxon ReferenceTaxon
         * @param parentTaxonGroup TaxonGroup
         * @return newInstance TaxonGroup2TaxonHierarchy
         */
        public static TaxonGroup2TaxonHierarchy newInstance(Date endDate, Boolean isInherited, ReferenceTaxon childReferenceTaxon, TaxonGroup parentTaxonGroup)
        {
            final TaxonGroup2TaxonHierarchy entity = new TaxonGroup2TaxonHierarchyImpl();
            entity.setEndDate(endDate);
            entity.setIsInherited(isInherited);
            entity.setChildReferenceTaxon(childReferenceTaxon);
            entity.setParentTaxonGroup(parentTaxonGroup);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TaxonGroup2TaxonHierarchy o)
    {
        int cmp = 0;
        if (this.getTaxonGroup2TaxonHierarchyPk() != null)
        {
            cmp = this.getTaxonGroup2TaxonHierarchyPk().compareTo(o.getTaxonGroup2TaxonHierarchyPk());
        }
        else
        {
            if (this.getEndDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndDate().compareTo(o.getEndDate()));
            }
            if (this.isIsInherited() != null)
            {
                cmp = (cmp != 0 ? cmp : this.isIsInherited().compareTo(o.isIsInherited()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TaxonGroup2TaxonHierarchy.java merge-point
}